# linkahead-cppinttest

Integration tests for linkahead-cpplib and the linkahead-server

# Dependencies

* clang-tidy-16
* clang-format
* iwyu / include-what-you-use
* cmake
* conan

# Run tests

## Prerequisites

Create a local conan package from the linkahead-cpplib repository

## Build & Execution

```
make test-release
```

or manually via

1. `conan install . -s build_type=<Debug/Release> --build=missing`
2. `cmake --preset conan-<debug/release>`
3. `cd build <Debug/Release>`
4. `cmake --build .`
5. Provide client configuration at `~/.linkahead-client.json` or via any other method described in the docs.
6. There are tests which need access to the server's certificate file. Define
   path to the pem file in the `CAOSDB_SERVER_CERT` environment variable.
7. Run with `ctest` in the build directory.

### Windows ###

On windows, you still need to build and create a conan package from
linkahead-cpplib using conan-create or the make.ps1 script in the
cpplib repo.

This repo also provides a make script `make.ps1` to run the
integration tests on Windows. You need to create a python virtual
environment and install the requirements from linkahead cpplib or
recycle the one you used to create the package there:

```sh
python -m venv .venv  # Choose any path you like for your venv
.venv/Scripts/Actvate.ps1
pip install ../linkahead-cpplib/requirements.txt  # You may need to change the pass to cpplib here
```

Then build and run the tests with

```sh
make.ps1 all
```

### Troubleshooting ###

- If you don't have `clang-tidy` installed, you can run the first `cmake` command with
  `LINTING=OFF`: `cmake -D LINTING=OFF -B . ..`

## Formatting, style, linting ##

`make format`
